\section{Results}
\label{sec:results}

The AMPL implementation described in \autoref{sec:implementation} has been used
to find the solution to the optimal control problem. Listings
\ref{lst:results-conopt}, \ref{lst:results-loqo}, \ref{lst:results-minos} and
\ref{lst:results-snopt} show the AMPL console output for each solver. One can
observe that the four solvers reach approximately the same solution.

One can deduce that minimizing \autoref{eqn:cost-function} will lead to
$x_1(t)$, $x_2(t)$ and $u(t)$ tending to $0$. If $x_2$ is considered as
velocity, $x_1$ as position and $u$ as a control that affects the acceleration
of the dynamic object, one can deduce that the minimization of the cost
function will lead the acceleration control and the velocity to $0$, while the
position will tend to stabilize in a fixed value. That is exactly the behaviour
that can be observed in figures \ref{fig:dynamic-object-position},
\ref{fig:dynamic-object-velocity} and \ref{fig:dynamic-object-control} from
$t=0$ until $t=0.2$.

But the problem does not only need to minimize the cost function, it is also
constrained by \autoref{eqn:state-constraint}. Which will alter the velocity of
the dynamic object, impeding it to stabilize at $0$. This behaviour can easily be
observed in \autoref{fig:dynamic-object-velocity}. A parabolic velocity
profile is imposed by the state constrain. Being $u(t)$ a control related to
the acceleration, a parabolic velocity profile correspond to a linear
acceleration profile and a cubic position profile. Which can be observed in the
figures as well.

We can conclude that the results are reasonable and expected.

\begin{figure}[h]
\begin{center}
\begin{tikzpicture}[
        %Environment Cfg.
        font=\bfseries\sffamily,
    ]
    \begin{axis}[
        width=0.8\textwidth,
        xmin=0,
        xmax=1,
        ymax=0,
        ymin=-0.25,
        grid=both,
        ylabel={$x_1(t)$},
        xlabel=$t$,
        tick align=outside,
        axis x line*=none,
        axis y line*=none,
        ylabel style={align=center,rotate=-90,color=blue!50!cyan},
    ]
    \addplot[color=blue!50!cyan,mark=square,tension=0.7,very thick] 
        table [x index=1,y index=2,col sep=comma] {P2_OC_4.csv};
    \end{axis}

\end{tikzpicture}
\end{center}
\caption{Dynamic object $x_1$: Position}
\label{fig:dynamic-object-position}
\end{figure}

\begin{figure}
\begin{center}
\begin{tikzpicture}[
        %Environment Cfg.
        font=\bfseries\sffamily,
    ]
    \begin{axis}[
        width=0.8\textwidth,
        xmin=0,
        xmax=1,
        grid=both,
        ylabel={$x_2(t)$},
        xlabel=$t$,
        tick align=outside,
        axis x line*=none,
        axis y line*=none,
        ylabel style={align=center,rotate=-90,color=orange!80},
    ]
    \addplot[color=gray!80,mark=square,tension=0.7,very thick] 
        table [x index=1,y index=4,col sep=comma] {P2_OC_4.csv};
    \node[text=gray!80,align=center,anchor=east,inner sep=5pt]
        at (0.9,1) {State\\ Constraint};
    \addplot[color=orange!80,mark=square,tension=0.7,very thick] 
        table [x index=1,y index=3,col sep=comma] {P2_OC_4.csv};
    \end{axis}

\end{tikzpicture}
\end{center}
\caption{Dynamic object $x_2(t)$: Velocity}
\label{fig:dynamic-object-velocity}
\end{figure}

\begin{figure}
\begin{center}
\begin{tikzpicture}[
        %Environment Cfg.
        font=\bfseries\sffamily,
    ]
    \begin{axis}[
        width=0.8\textwidth,
        xmin=0,
        xmax=1,
        grid=both,
        ylabel={$u(t)$},
        xlabel=$t$,
        tick align=outside,
        axis x line*=none,
        axis y line*=none,
        ylabel style={align=center,rotate=-90,color=violet!80},
    ]
    \addplot[color=violet!80,mark=square,tension=0.7,very thick] 
        table [x index=1,y index=5,col sep=comma] {P2_OC_4.csv};
    \end{axis}

\end{tikzpicture}
\end{center}
\caption{Dynamic object $u(t)$: Acceleration control}
\label{fig:dynamic-object-control}
\end{figure}

\clearpage
\lstinputlisting[label={lst:results-conopt},caption={AMPL console output with conopt solver}]{P2_OC_4_conopt}

\clearpage
\lstinputlisting[label={lst:results-loqo},caption={AMPL console output with loqo solver}]{P2_OC_4_loqo}

\clearpage
\lstinputlisting[label={lst:results-minos},caption={AMPL console output with minos solver}]{P2_OC_4_minos}

\clearpage
\lstinputlisting[label={lst:results-snopt},caption={AMPL console output with snopt solver}]{P2_OC_4_snopt}